; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; changes all longfilenames in current dir to lowercase
;  or directory/listing specified on Commandline
;
; do TOLOW /? for a version number listing only
; do TOLOW /d to change Directory names too. ***lower case D***
;  parameters must be as define above.
; TOLOW only works in current directory on filenames in current directory.
;
; Assembled with NBASM 00.26.31
;  http://www.fysnet.net/newbasic.htm
;
.model tiny
.code
.186

           ; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           ;  we use the GetVolume function to see if the LFN
           ;   functions are supported.
           ;  returns carry set and/or AX = 7100h if not supported
           stc                          ; make sure carry set
           mov  dx,offset name          ; 
           mov  di,offset Volume        ;
           mov  cx,32                   ;
           mov  ax,71A0h                ; see if support long filenames
           int  21h                     ;
           jc   short @f                ;
           cmp  ax,7100h                ;
           jne  short LFNsSupportted    ;

           ; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           ; if not supported, display error and exit
@@:        mov  dx,offset NoLng         ;
@@:        mov  ah,09h                  ;
           int  21h                     ;
           .exit


           ; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           ; See if the user wants us to print the version number only
           ;  if so, print it and exit by jumping back up a little ways.
LFNsSupportted:
           mov  dx,offset VerS          ;
           cmp  word [0082h],'?/'       ; if /? on command line then
           je   short @b                ; then just see version number 

           ; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           ; LFN FindFirst()
           ;  cl = allowable attributes
           ;  ch = required attributes
           ;  we set cx = 10h for directories if /d given on command line
           ;  this service ignores the archive and read/only bits anyway
           xor  cx,cx                   ; Attributes ignored (a/ro) (no dirs)
           cmp  word [0082h],'d/'       ; if /d on command line then
           jne  short @f                ; then change directory names too.
           mov  cl,10h                  ; allow dirs also
@@:        mov  ax,714Eh                ; find first long filename
           mov  dx,offset GetAll        ; '*' = match any file
           mov  si,01h                  ; Use DOS date/time format
           mov  di,offset FDRec         ; buffer to fill
           int  21h                     ; do it
           jc   short NoneAtAll         ; carry set means no files found
           mov  bx,ax                   ; save handle in bx

           ; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           ; here is were we make the string a lower case string
           ;  filename found is at offset 2Ch and is at max 260 bytes long
MainLoop:  mov  si,offset Longfilen     ; 
           mov  di,offset LFilename     ; our buffer to store the new filename
           mov  cx,260                  ; at max, 260 chars
LowerIt:   lodsb                        ;
           cmp  al,'A'                  ;
           jb   short @f                ;
           cmp  al,'Z'                  ;
           ja   short @f                ;
           add  al,32                   ;
@@:        stosb                        ;
           or   al,al                   ; if null char, end of string
           loopnz LowerIt               ;

           ; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           ; rename the file to our lowercase filename
           mov  ax,7156h                ; LFN rename it
           mov  dx,offset Longfilen     ;
           mov  di,offset LFilename     ;
           int  21h                     ;

           ; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           ; find the next one
           mov  ax,714Fh                ; find next long filename
           mov  si,01h                  ;   bx already equals handle
           mov  di,offset FDRec         ;
           int  21h                     ;
           jnc  short MainLoop          ; get another one

           ; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           ; no more, so close the handle
           mov  ax,71A1h                ; close long filename search
           int  21h                     ;   bx already equals handle

           ; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           ; done, so exit to DOS
NoneAtAll: .exit


; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; start of our data

NoLng      db  13,10,'Long Filenames not allowed.$'
VerS       db  13,10,'TOLOW  version 1.04a  =-=-=-=-=-=-=-=-=  Forever Young Software (c)1984-2010'
           db  13,10,36
GetAll     db  '*',0
Name       db  '\',0  ; root name

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; start of our uninitilized data
; this section does not take up .com file space

Volume     dup 32,?

FDRec      dup 44,?    ; attribs, time, last .., file size, etc.
Longfilen  dup 260,?            ; Longfilename
           dup 14,?             ; short file name

LFilename  dup 260,?            ; temp lower case file name storage

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; end of source code
.end


; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; more comments

Version History:
  1.00   - Initial release.                (size = 695 bytes)
  1.03   - Cut 495 bytes from .com file.   (size = 200 bytes)
         - (bug) now changes read/only files too.
         - removed unneccessary command line stuff
              (TOLOW only works in current dir)
  1.04   - Now allows the changing of Directory names with
              the /d switch.  (lower case D)
  1.04a  - Source clean up
         - removed the unneccassary 'check sp bug' stuff

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; end of file


